<html>
<head>
<title>OGRE: OgreRenderable.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRenderable.h</h1><a href="OgreRenderable_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Renderable_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Renderable_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>"</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include "<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>"</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include "<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>"</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include "<a class="code" href="OgreVector4_8h.html">OgreVector4.h</a>"</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include "<a class="code" href="OgreException_8h.html">OgreException.h</a>"</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>Ogre {
<a name="l00044"></a>00044 
<a name="l00056"></a><a class="code" href="classOgre_1_1Renderable.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1Renderable.html#ed186856b59bf967f3188bfa70546957">00059</a>         <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>() : mPolygonModeOverrideable(true), mUseIdentityProjection(false), mUseIdentityView(false) {}
<a name="l00061"></a><a class="code" href="classOgre_1_1Renderable.html#e5a6101851f1e45229f7b4bc20a69815">00061</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>() { }
<a name="l00067"></a>00067         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00073"></a><a class="code" href="classOgre_1_1Renderable.html#afcc80b06f8c74eaac3d35e72ca54842">00073</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> getMaterial()-&gt;getBestTechnique(); }
<a name="l00076"></a>00076         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op) = 0;
<a name="l00089"></a>00089         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* xform) <span class="keyword">const</span> = 0;
<a name="l00095"></a>00095         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getWorldOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00101"></a>00101         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getWorldPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00102"></a>00102 
<a name="l00111"></a><a class="code" href="classOgre_1_1Renderable.html#b6ecba3943f56182cddf3b3540afc760">00111</a>         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumWorldTransforms(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00112"></a>00112 
<a name="l00122"></a><a class="code" href="classOgre_1_1Renderable.html#4136ce4b9d3add5203339327015d872d">00122</a>         <span class="keywordtype">void</span> setUseIdentityProjection(<span class="keywordtype">bool</span> useIdentityProjection)
<a name="l00123"></a>00123         {
<a name="l00124"></a>00124             mUseIdentityProjection = useIdentityProjection;
<a name="l00125"></a>00125         }
<a name="l00126"></a>00126 
<a name="l00136"></a><a class="code" href="classOgre_1_1Renderable.html#2a8f061a5f322e0dae2fd6946fc2966f">00136</a>         <span class="keywordtype">bool</span> getUseIdentityProjection(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseIdentityProjection; }
<a name="l00137"></a>00137 
<a name="l00147"></a><a class="code" href="classOgre_1_1Renderable.html#e53cff42a16304f582ef83ad3017d614">00147</a>         <span class="keywordtype">void</span> setUseIdentityView(<span class="keywordtype">bool</span> useIdentityView)
<a name="l00148"></a>00148         {
<a name="l00149"></a>00149             mUseIdentityView = useIdentityView;
<a name="l00150"></a>00150         }
<a name="l00151"></a>00151 
<a name="l00161"></a><a class="code" href="classOgre_1_1Renderable.html#55df8c0a5347d589ee6ef7beaa38806e">00161</a>         <span class="keywordtype">bool</span> getUseIdentityView(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseIdentityView; }
<a name="l00162"></a>00162 
<a name="l00168"></a>00168         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span> = 0;
<a name="l00169"></a>00169 
<a name="l00171"></a><a class="code" href="classOgre_1_1Renderable.html#9dda967b054609898953bea98ea502b8">00171</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getNormaliseNormals(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00172"></a>00172 
<a name="l00177"></a>00177         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classOgre_1_1Renderable.html#1c122c0686168dac942700942bd9f8fc">00179</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a>&amp; getClipPlanes()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> msDummyPlaneList; };
<a name="l00180"></a>00180 
<a name="l00187"></a><a class="code" href="classOgre_1_1Renderable.html#1ce8341c18f75ef0b6d818eceea5b2e2">00187</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getCastsShadows(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00188"></a>00188 
<a name="l00204"></a><a class="code" href="classOgre_1_1Renderable.html#572c0331ef2ec650d56063fdc17435f5">00204</a>         <span class="keywordtype">void</span> setCustomParameter(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; value) 
<a name="l00205"></a>00205         {
<a name="l00206"></a>00206             mCustomParameters[index] = value;
<a name="l00207"></a>00207         }
<a name="l00208"></a>00208 
<a name="l00213"></a><a class="code" href="classOgre_1_1Renderable.html#7f5bd1dc9046cb31307ac53914c82fc9">00213</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; getCustomParameter(<span class="keywordtype">size_t</span> index)<span class="keyword"> const</span>
<a name="l00214"></a>00214 <span class="keyword">        </span>{
<a name="l00215"></a>00215             CustomParameterMap::const_iterator i = mCustomParameters.find(index);
<a name="l00216"></a>00216             <span class="keywordflow">if</span> (i != mCustomParameters.end())
<a name="l00217"></a>00217             {
<a name="l00218"></a>00218                 <span class="keywordflow">return</span> i-&gt;second;
<a name="l00219"></a>00219             }
<a name="l00220"></a>00220             <span class="keywordflow">else</span>
<a name="l00221"></a>00221             {
<a name="l00222"></a>00222                 <a class="code" href="OgreException_8h.html#6d8a74980f0e08e2a912cddc19be0fcd">OGRE_EXCEPT</a>(<a class="code" href="classOgre_1_1Exception.html#9bdf9b8a0a83b95818d676848beaa29b9f57f8f4aefb7fae5fcd69fe155e7003">Exception::ERR_ITEM_NOT_FOUND</a>, 
<a name="l00223"></a>00223                     <span class="stringliteral">"Parameter at the given index was not found."</span>,
<a name="l00224"></a>00224                     <span class="stringliteral">"Renderable::getCustomParameter"</span>);
<a name="l00225"></a>00225             }
<a name="l00226"></a>00226         }
<a name="l00227"></a>00227 
<a name="l00252"></a><a class="code" href="classOgre_1_1Renderable.html#42f520f7ba1c57e10130b81ed444affe">00252</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateCustomGpuParameter(
<a name="l00253"></a>00253             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html" title="Structure recording the use of an automatic parameter.">GpuProgramParameters::AutoConstantEntry</a>&amp; constantEntry,
<a name="l00254"></a>00254             <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* params)<span class="keyword"> const</span>
<a name="l00255"></a>00255 <span class="keyword">        </span>{
<a name="l00256"></a>00256             CustomParameterMap::const_iterator i = mCustomParameters.find(constantEntry.<a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#e2c1d1787dfea05c7d03d5651f62d4ae">data</a>);
<a name="l00257"></a>00257             <span class="keywordflow">if</span> (i != mCustomParameters.end())
<a name="l00258"></a>00258             {
<a name="l00259"></a>00259                 params-&gt;<a class="code" href="classOgre_1_1GpuProgramParameters.html#f9e29d2087c860156de6792405b679d4" title="Write a 4-element floating-point parameter to the program directly to the underlying...">_writeRawConstant</a>(constantEntry.<a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#e93ddb6e48d13e9768915de45c9a2c57" title="The target (physical) constant index.">physicalIndex</a>, i-&gt;second, 
<a name="l00260"></a>00260                     constantEntry.<a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#6cd2d6e06a33f89850e9a77e4d61cc00" title="The number of elements per individual entry in this constant Used in case people...">elementCount</a>);
<a name="l00261"></a>00261             }
<a name="l00262"></a>00262         }
<a name="l00263"></a>00263 
<a name="l00269"></a><a class="code" href="classOgre_1_1Renderable.html#2108dfc322953a7bd429be8b62811e56">00269</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPolygonModeOverrideable(<span class="keywordtype">bool</span> <span class="keyword">override</span>)
<a name="l00270"></a>00270         {
<a name="l00271"></a>00271             mPolygonModeOverrideable = <span class="keyword">override</span>;
<a name="l00272"></a>00272         }
<a name="l00273"></a>00273 
<a name="l00277"></a><a class="code" href="classOgre_1_1Renderable.html#723105bef101e2385747f214348984b5">00277</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getPolygonModeOverrideable(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00278"></a>00278 <span class="keyword">        </span>{
<a name="l00279"></a>00279             <span class="keywordflow">return</span> mPolygonModeOverrideable;
<a name="l00280"></a>00280         }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283     <span class="keyword">protected</span>:
<a name="l00284"></a><a class="code" href="classOgre_1_1Renderable.html#fb8c005cd3df11a051304937ad322112">00284</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a> msDummyPlaneList;
<a name="l00285"></a><a class="code" href="classOgre_1_1Renderable.html#3e944b6d42bc87a19c02f3cc6e677f26">00285</a>         <span class="keyword">typedef</span> std::map&lt;size_t, Vector4&gt; CustomParameterMap;
<a name="l00286"></a><a class="code" href="classOgre_1_1Renderable.html#7b91506fcf7007e1bf512dade4682731">00286</a>         CustomParameterMap mCustomParameters;
<a name="l00287"></a><a class="code" href="classOgre_1_1Renderable.html#4b7b701d41bfd85656829261cbcb3495">00287</a>         <span class="keywordtype">bool</span> mPolygonModeOverrideable;
<a name="l00288"></a><a class="code" href="classOgre_1_1Renderable.html#27ee15aed77a5bf84b2c3f80c060616e">00288</a>         <span class="keywordtype">bool</span> mUseIdentityProjection;
<a name="l00289"></a><a class="code" href="classOgre_1_1Renderable.html#536d8ef571a7a177d94e8a6203bd0b35">00289</a>         <span class="keywordtype">bool</span> mUseIdentityView;
<a name="l00290"></a>00290     };
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="preprocessor">#endif //__Renderable_H__</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
